"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/index.ts
var src_exports = {};
__export(src_exports, {
  default: () => src_default
});
module.exports = __toCommonJS(src_exports);

// src/csv.ts
var import_core = require("@csv-js/core");
var Csv = class {
  constructor(header, options) {
    this.data = [];
    this.info = {
      name: `csvjs-${+new Date()}`
    };
    this.header = header;
    if (options && options.name) {
      this.info.name = options.name;
    }
  }
  append(row) {
    const rows = (0, import_core.isArray)(row) ? row : [row];
    this.data.push(...rows);
  }
  prepend(row) {
    const rows = (0, import_core.isArray)(row) ? row : [row];
    this.data.unshift(...rows);
  }
  insert(index, row) {
    const rows = (0, import_core.isArray)(row) ? row : [row];
    this.data.splice(index, 0, ...rows);
  }
  remove(index) {
    this.data.splice(index, 1);
  }
  cover(index, row) {
    this.data[index] = row;
  }
  findIndexes(key, value) {
    const result = [];
    this.data.forEach((val, index) => {
      if (val[key] === value)
        result.push(index);
    });
    return result;
  }
  toString() {
    return (0, import_core.stringifyCsv)(
      this.data,
      this.header
    );
  }
  toHeaderKeys() {
    return this.header.map((v) => v.key);
  }
  download(name = "") {
    (0, import_core.downloadCsvFile)(
      name || this.info.name,
      this.toString()
    );
  }
  static import(csvString, headerKeys, options) {
    const { data, header } = (0, import_core.parseCsv)(csvString, headerKeys);
    const instance = new this(header, options);
    instance.append(data);
    return instance;
  }
};

// src/index.ts
var src_default = Csv;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
